<script setup lang="ts">
  import { required } from '@vuelidate/validators';
  import { useVuelidate } from '@vuelidate/core';
  import { ClientApiError } from '@shopware-pwa/types';
  import { getErrorMessages } from '~/helpers/errors';
  import { DAILY_PRIVACY_POLICY_LINK } from '~/helpers/constants';

  definePageMeta({
    middleware: 'guide-auth-guard',
  });

  const localePath = useLocalePath();
  const { isGuideAuthenticated, authenticate } = useAdminApiInstance();
  const { getVideoAndAudioSetting, mediaShouldBeUsed } = useAppointment();
  const router = useRouter();
  const route = useRoute();
  const isLoading = ref<boolean>();
  const loginErrorMsg = ref<string>();

  onBeforeMount(async () => {
    await getVideoAndAudioSetting();
  });

  const state = reactive({
    username: '',
    password: '',
    agree: false,
  });

  const rules = {
    username: {
      required,
    },
    password: {
      required,
    },
    agree: {
      checked: (value: any) => {
        if (!mediaShouldBeUsed.value) {
          return true;
        } else {
          return value === true;
        }
      },
    },
  };

  const $v = useVuelidate(rules, state);

  const invokeLogin = async (e: Event) => {
    e.preventDefault();
    $v.value.$touch();
    const valid = await $v.value.$validate();
    if (valid) {
      try {
        isLoading.value = true;
        await authenticate(state.username, state.password);
        const appointmentId = route.params.appointmentId as string;
        router.push(localePath({ name: 'guide-appointmentId', params: { appointmentId } }));
      } catch (e) {
        loginErrorMsg.value = getErrorMessages(e as ClientApiError) as string;
      } finally {
        isLoading.value = false;
      }
    }
  };
</script>
<template>
  <div class="min-h-100vh container mx-auto flex flex-col items-center justify-center">
    <form
      v-if="!isGuideAuthenticated"
      class="w-9/10 flex max-w-sm flex-col gap-6 px-3"
      autocomplete="on"
      @submit="invokeLogin"
    >
      <h2 class="font-bold">{{ $t('loginAsGuide') }}</h2>
      <SwTextField
        id="username"
        v-model="state.username"
        :placeholder="$t('loginForm.emailPlaceholder')"
        name="username"
        type="username"
        :errors="$v.username.$errors"
        :label="$t('emailAddress')"
      />

      <SwTextField
        id="password"
        v-model="state.password"
        :placeholder="$t('loginForm.passwordPlaceholder')"
        name="password"
        type="password"
        :errors="$v.password.$errors"
        :label="$t('password')"
      />

      <SwBanner v-if="loginErrorMsg" variant="error" :show-close-btn="false">
        {{ $t(loginErrorMsg) }}
      </SwBanner>
      <SwCheckbox
        v-if="mediaShouldBeUsed"
        v-model="state.agree"
        class="py-2"
        :errors="$v.agree.$errors"
      >
        <template #label>
          <i18n-t keypath="agreeTermsDailyPrivacyPolicy" :tag="false">
            <template #privacyPolicy>
              <SwLink :to="DAILY_PRIVACY_POLICY_LINK" target="_blank">
                {{ $t('privacyPolicy') }}
              </SwLink>
            </template>
          </i18n-t>
        </template>
      </SwCheckbox>
      <div>
        <SwButton type="submit" :loading="isLoading" variant="primary">{{ $t('login') }}</SwButton>
      </div>
    </form>
  </div>
</template>
